/*
 *  TOPPERS ECHONET Lite Communication Middleware
 *
 *  Copyright (C) 2014 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: if_rx62n.c 108 2015-06-11 09:15:46Z coas-nagasima $
 */

#define CAST(type, val)		((type)(val))

#include <kernel.h>
#include <sil.h>
#include <t_syslog.h>
#include <string.h>
#include "kernel_cfg.h"
#include "kernel/kernel_impl.h"
#include "uip_target_config.h"
#include "uip_arp.h"
#include "if_rx62n.h"
#include "ether_phy.h"

extern uint8_t mac_addr[ETHER_ADDR_LEN];

/*
 *  lbg[NC^tF[XɈˑ\tgEFA 
 */

typedef struct t_rx62n_softc {
	T_RX62N_TX_DESC *tx_write;
	T_RX62N_RX_DESC *rx_read;
	PHY_STATE_T state;
} T_RX62N_SOFTC;

/*
 *  lbg[NC^tF[X̃\tgEFA
 */

/* lbg[NC^tF[XɈˑ\tgEFA */

static T_RX62N_SOFTC rx62n_softc;

typedef struct t_rx62n_buf {
	uint8_t rx_buff[NUM_IF_RX62N_RXBUF][32 * ((IF_RX62N_BUF_PAGE_SIZE + 31) / 32)];
	uint8_t tx_buff[NUM_IF_RX62N_TXBUF][32 * ((IF_RX62N_BUF_PAGE_SIZE + 31) / 32)];
	T_RX62N_RX_DESC rx_desc[NUM_IF_RX62N_RXBUF];
	T_RX62N_TX_DESC tx_desc[NUM_IF_RX62N_TXBUF];
} T_RX62N_BUF;

#if defined(__RX)
#pragma	section	ETH_MEMORY
#endif
T_RX62N_BUF rx62n_buf;
#if defined(__RX)
#pragma	section
#endif

/* lbg[NC^tF[XɈˑȂ\tgEFA */

T_IF_SOFTC if_softc = {
//	{0,},						/* lbg[NC^tF[X̃AhX	*/
//	0,							/* M^CAEg			*/
	&rx62n_softc,				/* fBoCXˑ̃\tgEFA	*/
};

/*
 *  Ǐϐ
 */

static void rx62n_stop (T_RX62N_SOFTC *sc);
static void rx62n_init_sub (T_IF_SOFTC *ic);
static void rx62n_set_ecmr (T_IF_SOFTC *ic, PHY_MODE_T mode);

/*
 *  rx62n_stop -- lbg[NC^tF[X~B
 * 
 *    : NIC 荞݋֎~ԂŌĂяoƁB
 */

static void
rx62n_stop (T_RX62N_SOFTC *sc)
{
	/* 샂[hNA */
	sil_wrw_mem(ETHERC_ECMR, 0x00000000);
}

/*
 *  rx62n_init_sub -- lbg[NC^tF[X̏
 * 
 *    : NIC 荞݋֎~ԂŌĂяoƁB
 */

static void
rx62n_init_sub (T_IF_SOFTC *ic)
{
	int i;
	PHY_STATE_T state = PHY_STATE_UNINIT;

	/* MAC\tgEGAEZbg */
	sil_wrw_mem(EDMAC_EDMR, sil_rew_mem(EDMAC_EDMR) | EDMAC_EDMR_SWR_BIT);

	/* Zbg҂ */
	for (i = 0; i < 10000; i++) {
	}

	sil_wrw_mem(ETHERC_MAHR, ((uint32_t)mac_addr[0] << 24)
		| ((uint32_t)mac_addr[1] << 16) | ((uint32_t)mac_addr[2] << 8 )
		|  (uint32_t)mac_addr[3]);
	sil_wrw_mem(ETHERC_MALR, ((uint32_t)mac_addr[4] << 8 )
		| (uint32_t)mac_addr[5]);

	/* PHYZbg */
	while((state = phy_reset(state, 0)) != PHY_STATE_RESET);
	ic->sc->state = state;

	/* Clear all ETHERC status BFR, PSRTO, LCHNG, MPD, ICD */
	sil_wrw_mem(ETHERC_ECSR, 0x00000037);

	/* Nω荞ݗL */
	sil_wrw_mem(ETHERC_ECSIPR, sil_rew_mem(ETHERC_ECSIPR) | ETHERC_ECSIPR_LCHNGIP);

	/* Clear all ETHERC and EDMAC status bits */
	sil_wrw_mem(EDMAC_EESR, 0x47FF0F9F);

	/* M荞ݗL */
	sil_wrw_mem(EDMAC_EESIPR, (EDMAC_EESIPR_TCIP | EDMAC_EESIPR_FRIP | EDMAC_EESIPR_RDEIP | EDMAC_EESIPR_FROFIP));

	/* Mt[iobt@TCYj */
	sil_wrw_mem(ETHERC_RFLR, IF_RX62N_BUF_PAGE_SIZE);

	/* 96rbgԁilj */
	sil_wrw_mem(ETHERC_IPGR, 0x00000014);

	/* Set little endian mode */
	sil_wrw_mem(EDMAC_EDMR, sil_rew_mem(EDMAC_EDMR) | EDMAC_EDMR_DE_BIT);

	/* Initialize Rx descriptor list address */
	sil_wrw_mem(EDMAC_RDLAR, (uint32_t)rx62n_buf.rx_desc);
	/* Initialize Tx descriptor list address */
	sil_wrw_mem(EDMAC_TDLAR, (uint32_t)rx62n_buf.tx_desc);
	/* Copy-back status is RFE & TFE only */
	sil_wrw_mem(EDMAC_TRSCER, 0x00000000);
	/* Threshold of Tx_FIFO */
	sil_wrw_mem(EDMAC_TFTR, 0x00000000);
	/* Transmit fifo & receive fifo is 2048 bytes */
	sil_wrw_mem(EDMAC_FDR, 0x00000707);
	/* RR in EDRRR is under driver control */
	sil_wrw_mem(EDMAC_RMCR, 0x00000001);

	/* PHY̏𑣂 */
	ic->link_pre = true;
	ic->link_now = false;

	/* ^[Qbgˑ̊ݏ */
	rx62n_inter_init();
}

/*
 *  rx62n_set_ecmr -- ECMRWX^̐ݒ
 */

static void
rx62n_set_ecmr (T_IF_SOFTC *ic, PHY_MODE_T mode)
{
	uint32_t ecmr;

	ecmr = ETHERC_ECMR_RE | ETHERC_ECMR_TE/* | ETHERC_ECMR_PRM*/;

	if ((mode & 0x01) != 0)
		ecmr |= ETHERC_ECMR_DM;
	if ((mode & 0x02) != 0)
		ecmr |= ETHERC_ECMR_RTM;

	/* 샂[hݒ */
	sil_wrw_mem(ETHERC_ECMR, ecmr);
}

/*
 * rx62n_reset -- lbg[NC^tF[XZbgB
 */

void
rx62n_reset (T_IF_SOFTC *ic)
{
	/* NIC ̊荞݂֎~B*/
	dis_int(INTNO_IF_RX62N_TRX);

	rx62n_stop(ic->sc);
	rx62n_init_sub(ic);

	/* NIC ̊荞݂B*/
	ena_int(INTNO_IF_RX62N_TRX);
}

/*
 *  get_rx62n_softc -- lbg[NC^tF[X̃\tgEFAԂB
 */

T_IF_SOFTC *
rx62n_get_softc (void)
{
	return &if_softc;
}

/*
 * rx62n_watchdog -- lbg[NC^tF[X̃b`hbO^CAEg
 */

void
rx62n_watchdog (T_IF_SOFTC *ic)
{
	rx62n_reset(ic);
}

/*
 * rx62n_probe -- lbg[NC^tF[X̌o
 */

void
rx62n_probe (T_IF_SOFTC *ic)
{
	/* ^[Qbgˑ̃oX̏ */
	rx62n_bus_init();

	memcpy(uip_ethaddr.addr, mac_addr, sizeof(uip_ethaddr.addr));
}

/*
 * rx62n_init -- lbg[NC^tF[X̏
 */

void
rx62n_init (T_IF_SOFTC *ic)
{
	T_RX62N_SOFTC *sc = ic->sc;
	T_RX62N_TX_DESC *tdsc;
	T_RX62N_RX_DESC *rdsc;
	int i;

	/* NIC ̊荞݂֎~B*/
	dis_int(INTNO_IF_RX62N_TRX);

	tdsc = (T_RX62N_TX_DESC *)rx62n_buf.tx_desc;
	sc->tx_write = tdsc;
	for ( i=0 ; i < NUM_IF_RX62N_TXBUF ; i++ ) {
		memset(tdsc, 0, sizeof(*tdsc));
		tdsc->tbl = 0;
		tdsc->tba = (uint32_t)&rx62n_buf.tx_buff[i];
		tdsc++;
	}
	tdsc--;
	tdsc->tdle = 1;

	rdsc = (T_RX62N_RX_DESC *)rx62n_buf.rx_desc;
	sc->rx_read = rdsc;
	for ( i=0 ; i < NUM_IF_RX62N_RXBUF ; i++ ) {
		memset(rdsc, 0, sizeof(*rdsc));
		rdsc->rbl = IF_RX62N_BUF_PAGE_SIZE;
		rdsc->rba = (uint32_t)&rx62n_buf.rx_buff[i];
		rdsc->rfl = 0;
		rdsc->ract = 1;
		rdsc++;
	}
	rdsc--;
	rdsc->rdle = 1;

	/* rx62n_init {̂ĂяoB*/
	rx62n_init_sub(ic);

	if (sil_rew_mem(EDMAC_EDRRR) == 0) {
		sil_wrw_mem(EDMAC_EDRRR, EDMAC_EDRRR_RR);
	}

	/* NIC ̊荞݂B*/
	ena_int(INTNO_IF_RX62N_TRX);
}

/* 
 * rx62n_link -- NԂ̕ωɑ΂鏈
 */
bool_t
rx62n_link(T_IF_SOFTC *ic)
{
	T_RX62N_SOFTC *sc = ic->sc;
	PHY_MODE_T mode;

	if(sc->state == PHY_STATE_NEGOTIATED){
		ic->link_now = phy_is_link(0);
		if(!ic->link_now)
			sc->state = PHY_STATE_RESET;
		return true;
	}

	/* PHY̏ */
	sc->state = phy_initialize(sc->state, 0, &mode);
	if(sc->state != PHY_STATE_NEGOTIATED){
		return false;
	}

	/* ECMRWX^̐ݒ */
	rx62n_set_ecmr(ic, mode);
	return true;
}

/*
 * rx62n_read -- t[̓ǂݍ
 */

int
rx62n_read (T_IF_SOFTC *ic, void **input)
{
	T_RX62N_SOFTC *sc = ic->sc;
	T_RX62N_RX_DESC *desc;
	uint16_t len;

	if (ic->over_flow) {
		ic->over_flow = false;
	}

	desc = sc->rx_read;

	if (desc->ract != 0) {
		return 0;
	}

	len = desc->rfl;
	memcpy(*input, (void *)desc->rba, len);

	desc->rfp = 0;
	desc->ract = 1;

	desc++;
	if (desc == &rx62n_buf.rx_desc[NUM_IF_RX62N_RXBUF]) {
		desc = rx62n_buf.rx_desc;
	}
	sc->rx_read = desc;

	if (sil_rew_mem(EDMAC_EDRRR) == 0) {
		sil_wrw_mem(EDMAC_EDRRR, EDMAC_EDRRR_RR);
	}

	if ((ic->rxb_read == ic->rxb_write) && (desc->ract == 0))
		ic->rxb_read--;

	return len;
}

/*
 * rx62n_start -- Mt[obt@OB
 */

void
rx62n_start (T_IF_SOFTC *ic, void *output, int size)
{
	T_RX62N_SOFTC *sc = ic->sc;
	T_RX62N_TX_DESC *desc, *next;
	uint8_t *buf = NULL;
	int32_t len, res, pos;
	uint32_t tfp;

	for ( res = size, pos = 0; res > 0; res -= len, pos += len ) {
		desc = sc->tx_write;

		if (desc->tact != 0) {
			break;
		}

		buf = (uint8_t *)desc->tba;

		next = desc + 1;
		if (next == &rx62n_buf.tx_desc[NUM_IF_RX62N_TXBUF]) {
			next = rx62n_buf.tx_desc;
		}
		sc->tx_write = next;

		len = res;
		if ( len > IF_RX62N_BUF_PAGE_SIZE ) {
			len = IF_RX62N_BUF_PAGE_SIZE;
			tfp = 0x0;
		}
		else
			tfp = 0x1;

		if (pos == 0)
			tfp |= 0x2;

		memcpy(buf, (uint8_t *)output + pos, len);

		desc->tbl = len;
		desc->tfp = tfp;
		desc->tact = 1;
	}

	if (sil_rew_mem(EDMAC_EDTRR) == 0) {
		sil_wrw_mem(EDMAC_EDTRR, EDMAC_EDTRR_TR);
	}
}

/*
 *  RX62N Ethernet Controler M荞݃nh
 */

void
if_rx62n_trx_handler (void)
{
	T_IF_SOFTC *ic;
	T_RX62N_SOFTC *sc;
	uint32_t ecsr, eesr, psr;
	bool_t acttsk;

	i_begin_int(INTNO_IF_RX62N_TRX);

	ic = &if_softc;
	sc = ic->sc;

	ecsr = sil_rew_mem(ETHERC_ECSR);

	if (ecsr & ETHERC_ECSR_LCHNG) {
		/* ETHERC荞ݗvNA */
		sil_wrw_mem(ETHERC_ECSR, ETHERC_ECSR_LCHNG);

		psr = sil_rew_mem(ETHERC_PSR);
		ic->link_now = (psr & ETHERC_PSR_LMON) != 0;

		/* NԂɕω */
		if (ic->link_pre != ic->link_now) {
			/* M荞ݏ */
			acttsk = true;
		}
	}

	eesr = sil_rew_mem(EDMAC_EESR);

	if (eesr & EDMAC_EESR_FR) {
		/* DMA荞ݗvNA */
		sil_wrw_mem(EDMAC_EESR, EDMAC_EESR_FR);

		/* M荞ݏ */
		acttsk = true;
		ic->rxb_write++;
	}
	if (eesr & EDMAC_EESR_TC) {
		/* DMA荞ݗvNA */
		sil_wrw_mem(EDMAC_EESR, EDMAC_EESR_TC);

		/* M荞ݏ */
		acttsk = true;
	}
	if (eesr & (EDMAC_EESR_FROF | EDMAC_EESR_RDE)) {
		/* DMA荞ݗvNA */
		sil_wrw_mem(EDMAC_EESR, EDMAC_EESR_FROF | EDMAC_EESR_RDE);

		ic->over_flow = true;

		/* M荞ݏ */
		acttsk = true;
		ic->rxb_write++;
	}

	if(acttsk)
		iact_tsk(UIP_TASK);

	i_end_int(INTNO_IF_RX62N_TRX);
}
